<?php
/*
 * file contain main function that runs in admin side.
 *
 */
class ControllerExtensionModulesmsirv2 extends Controller {
	private $version = '1.0.0';
	private $error = array();
    private $_call_model = 'model_extension_module_smsirv2';
    private $_module_path = 'extension/module/smsirv2';
    private $_smsir_module;

    public function __construct($registry){
        parent::__construct($registry);
        if (version_compare(VERSION, '2.3.0.0', '<')) {
            $this->_module_path = 'module/smsir';
        }
        $this->_smsir_module = $this->{$this->_call_model};
    }

    /* ایجاد صفحه افزونه در مدیریت */
	public function index() {
		$this->load->language($this->_module_path);

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));

		$this->load->model($this->_module_path);

		$this->getList();
	}

	/* دستور ذخیره قالب*/
	public function insert() {

		$this->load->language($this->_module_path);

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));

		$this->load->model($this->_module_path);

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->_smsir_module->addTemplate($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getForm();
	}

	/* دستور ویرایش قالب */
	public function update() {
		$this->load->language($this->_module_path);

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));

		$this->load->model($this->_module_path);

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->_smsir_module->editTemplate($this->request->get['template_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getForm();
	}
	/* دستور ارسال پیامک */
	public function sendsms() {
		$this->load->language($this->_module_path);
		$this->load->model($this->_module_path);
		//$result = $this->_smsir_module->parseSMS('send_sms', 1, $this->request->post['phonenumber'], $this->request->post['smstext']);
		$result = $this->_smsir_module->sendSMS($this->request->post['phonenumber'], $this->request->post['smstext']);
		//if($result == true) $result = 'true'; else $result = 'false';
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode(array('result'=> $result)));
	}
	/* دستور ارسال پیامک به تمام مشتریان*/
	public function sendtoall() {
		$this->load->model('customer/customer');
		$filters = array();
		if($this->request->post['filter_customer_state'] != '') $filters['filter_status'] = $this->request->post['filter_customer_state'];
		if($this->request->post['filter_customer_affiliate'] != '') $filters['filter_affiliate'] = $this->request->post['filter_customer_affiliate'];
		if($this->request->post['filter_customer_newsletter'] != '') $filters['filter_newsletter'] = $this->request->post['filter_customer_newsletter'];
		if($this->request->post['filter_customer_group_id'] != '') $filters['filter_customer_group_id'] = $this->request->post['filter_customer_group_id'];
		$customers = $this->model_customer_customer->getCustomers($filters);
		$find = array(
			'{firstname}',
			'{lastname}',
			'{email}',
			'{telephone}',
		);
		foreach($customers as $customer){
			if($customer['telephone'] != ''){
				$replace = array(
					'firstname' => $customer['firstname'],
					'lastname'  => $customer['lastname'],
					'email'   => $customer['email'],
					'telephone' => $customer['telephone'],
				);

				$telephons[] = $customer['telephone'];
				$textarray[] = trim(str_replace($find, $replace, $this->request->post['smstexttoall']));
			}
		}
		$this->load->language($this->_module_path);
		$this->load->model($this->_module_path);
		$debug = $this->config->get('smsirv2_debug');
		if($debug == 1){
			$result = false;
			$res = 'دیباگ روشن است. پیامک شما در صورت خاموشی دیباگ به '.count($telephons).' مشتری ارسال خواهد شد.';
		} else {
            $telephons = array_chunk($telephons,100);
            $textarray = array_chunk($textarray, 100);
            for ($i=0, $iMax = count($telephons); $i< $iMax; $i++) {
                $result = $this->_smsir_module->sendSMS($telephons[$i], $textarray[$i], false, true);
            }
			$res = count($telephons);
		}
        if ($result) $result= 'true';
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode(array('result'=> $result, 'res'=>$res)));
	}
	/* دستور شمارش تعداد مشتریان*/
	public function customercount() {
		$this->load->model('customer/customer');
		$filters = array();
		if($_POST['filter_customer_state'] != '') $filters['filter_status'] = $_POST['filter_customer_state'];
		if($_POST['filter_customer_affiliate'] != '') $filters['filter_affiliate'] = $_POST['filter_customer_affiliate'];
		if($_POST['filter_customer_newsletter'] != '') $filters['filter_newsletter'] = $_POST['filter_customer_newsletter'];
		if($_POST['filter_customer_group_id'] != '') $filters['filter_customer_group_id'] = $_POST['filter_customer_group_id'];

		$customers = $this->model_customer_customer->getCustomers($filters);
		$customer_count = count($customers);

		if($customer_count) $result = 'true'; else $result = 'false';
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode(array('result'=> $result,'res'=>$customer_count)));
	}

	/* ارسال پیامک کاستوم به ممشتریان*/
	public function sendCustomSms()
    {
		$this->load->model($this->_module_path);
		$this->load->model('sale/order');
		$order_id = $_POST['order_id'];
		$order_info = $this->model_sale_order->getOrder($order_id);
		if ($order_info) {
			// Order confirmation
			if ($order_info['order_status_id']) {
				if ($order_info['payment_address_format']) {
					$format = $order_info['payment_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['payment_firstname'],
					'lastname'  => $order_info['payment_lastname'],
					'company'   => $order_info['payment_company'],
					'address_1' => $order_info['payment_address_1'],
					'address_2' => $order_info['payment_address_2'],
					'city'      => $order_info['payment_city'],
					'postcode'  => $order_info['payment_postcode'],
					'zone'      => $order_info['payment_zone'],
					'country'   => $order_info['payment_country']
				);

				$payment_address = trim(str_replace($find, $replace, $format));

				if ($order_info['shipping_address_format']) {
					$format = $order_info['shipping_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['shipping_firstname'],
					'lastname'  => $order_info['shipping_lastname'],
					'company'   => $order_info['shipping_company'],
					'address_1' => $order_info['shipping_address_1'],
					'address_2' => $order_info['shipping_address_2'],
					'city'      => $order_info['shipping_city'],
					'postcode'  => $order_info['shipping_postcode'],
					'zone'      => $order_info['shipping_zone'],
					'country'   => $order_info['shipping_country']
				);

				$shipping_address = trim(str_replace($find, $replace, $format));

				$order_product_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$order_id . "'");

				$plain_product_table = '';
				$vendors = array();
				foreach ($order_product_query->rows as $product) {
					$plain_product_table .= $product['quantity'] . 'x ' . $product['name'];

					$order_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$order_id . "' AND order_product_id = '" . (int)$product['order_product_id'] . "'");

					foreach ($order_option_query->rows as $option) {
						$plain_product_table .= '- ' . $option['name'] . ': ' . $option['value'] . "\n";
					}
				}
				$replace = array(
                    'firstname' => $order_info['firstname'],
                    'lastname' => $order_info['lastname'],
                    'email' => $order_info['email'],
                    'telephone' => $order_info['telephone'],
                    'order_id' => $order_info['order_id'],
                    'date_added' => date($this->language->get('date_format_short'), strtotime($order_info['date_added'])),
                    'payment_method' => $order_info['payment_method'],
                    'shipping_method' => $order_info['shipping_method'],
                    'ip' => $order_info['ip'],
                    'order_comment' => '',
                    'payment_address' => $payment_address,
                    'shipping_address' => $shipping_address,
                    'products' => $plain_product_table,
                    'store_name' => $this->config->get('config_name'),
                    'order_amount' => $this->currency->format($order_info['total'], $this->config->get('config_currency')),
				);
				$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}',
				'{store_name}',
				'{order_amount}',
			);
			    $message = strip_tags(str_replace($search, $replace, html_entity_decode($_POST['message'])));
				$response = $this->_smsir_module->sendSMS($order_info['telephone'], $message);
				if($response === true) $result = 'true'; else $result = $result;
				$this->response->addHeader('Content-Type: application/json');
				$this->response->setOutput(json_encode(array('result'=> $result)));
			}
		}
    }

	/* دستور ارسال پیامک تست*/
	public function sms_test() {
		$this->load->language($this->_module_path);
		$this->load->model($this->_module_path);
		$result = $this->_smsir_module->sendSMS($this->request->post['phonenumber'], $this->request->post['smstext']);
		if($result === true) $result = 'true'; else $result = $result;
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode(array('result'=> $result)));
	}

	/* دستور بررسی پترن*/
	public function checkpattern() {
		$this->load->language($this->_module_path);
		$this->load->model($this->_module_path);
		$result = $this->_smsir_module->checkPattern($this->request->post['pcode']);

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($result));
	}

	/* دستور حذف قالب */
	public function delete() {
		$this->load->language($this->_module_path);
		$this->document->setTitle(strip_tags($this->language->get('heading_title')));
		$this->load->model($this->_module_path);
		if (isset($this->request->post['selected']) && $this->request->server['REQUEST_METHOD'] == 'POST' && $this->validateDelete()) {
			foreach ($this->request->post['selected'] as $template_id) {
				$this->_smsir_module->deleteTemplate($template_id);
			}
			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'] . $url, true));
		}

		$this->getList();
	}

	/* دستور کپی قالب*/
	public function copy() {
		$this->load->language($this->_module_path);

		$this->document->setTitle(strip_tags($this->language->get('heading_title')));

		$this->load->model($this->_module_path);

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && isset($this->request->post['selected'])) {
			foreach ($this->request->post['selected'] as $template_id) {
				$template_info = $this->_smsir_module->getTemplate($template_id);

				$template_info['name'] .= ' Copy';

				$this->_smsir_module->addTemplate($template_info);
			}

			$this->session->data['success'] = $this->language->get('text_success');
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$this->response->redirect($this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'] . $url, true));
	}

	/* تهیه لیست قالب ها */
	protected function getList() {
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data = array(
			'sort'		=> $sort,
			'order'		=> $order,
			'page'		=> $page,
			'start'		=> $this->config->get('config_admin_limit') * ($page - 1),
			'limit'		=> $this->config->get('config_admin_limit')
		);

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], true)
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'], true)
   		);

		$data['heading_title'] = $this->language->get('heading_title');

		$data['column_name'] = $this->language->get('column_name');
		$data['column_type'] = $this->language->get('column_type');
		$data['column_store'] = $this->language->get('column_store');
		$data['column_action'] = $this->language->get('column_action');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['tab_config'] = $this->language->get('tab_config');
		$data['tab_list'] = $this->language->get('tab_list');

		$data['entry_username'] = $this->language->get('entry_username');
		$data['entry_password'] = $this->language->get('entry_password');
		$data['entry_default_from'] = $this->language->get('entry_default_from');
		$data['entry_debug'] = $this->language->get('entry_debug');

		$data['text_no_results'] = $this->language->get('text_no_results');

		$data['button_insert'] = $this->language->get('button_insert');
		$data['button_delete'] = $this->language->get('button_delete');
		$data['button_copy'] = $this->language->get('button_copy');

		$data['copy'] = $this->url->link('extension/module/smsirv2/copy', 'user_token=' . $this->session->data['user_token'], true);
		$data['action'] = $this->url->link('extension/module/smsirv2/delete', 'user_token=' . $this->session->data['user_token'], true);
		$data['sendsms_action'] = $this->url->link('extension/module/smsirv2/sendsms', 'user_token=' . $this->session->data['user_token'], true);
		$data['sendtoall_action'] = $this->url->link('extension/module/smsirv2/sendtoall', 'user_token=' . $this->session->data['user_token'], true);
		$data['insert'] = $this->url->link('extension/module/smsirv2/insert', 'user_token=' . $this->session->data['user_token'], true);
		$data['user_token'] = $this->session->data['user_token'];

		$data['smsirv2_username'] = $this->config->get('smsirv2_username');
		$data['smsirv2_api_key'] = $this->config->get('smsirv2_api_key');
		$data['smsirv2_line_number'] = $this->config->get('smsirv2_line_number');
		$data['smsirv2_default_from'] = $this->config->get('smsirv2_default_from');
		$data['smsirv2_domain'] = $this->config->get('smsirv2_domain');
		$data['smsirv2_forgotten'] = $this->config->get('smsirv2_forgotten');
		$data['smsirv2_debug'] = $this->config->get('smsirv2_debug');
		$data['module_smsirv2_status'] = $this->config->get('module_smsirv2_status');
		$panelBox = '';
		if($data['smsirv2_username'] && $data['smsirv2_api_key']) {
			$credit = $this->_smsir_module->getCredit($this->config->get('smsirv2_api_key'));
				if(is_numeric($credit)){
					$credit_help = '';
					if($credit < 10000 && $credit > 1000) {
						$alertClass = "notice-warning";
						$credit_help = ' (<i> جهت شارژ اعتبار به پنل پیامک مراجعه و گزینه شارژ حساب را کلیک نمایید. </i>)';
					} elseif ($credit < 1000){
						$alertClass = "notice-error";
						$credit_help = ' (<i> جهت شارژ اعتبار به پنل پیامک مراجعه و گزینه شارژ حساب را کلیک نمایید. </i>)';
					} else {
						$alertClass = "notice-info";
					}
					$credit = number_format($credit).' '.$credit_help;

				} else {
					$credit = 'امکان بررسی اعتبار شما از پنل پیامک نیست. خطای درگاه: '.$credit;
					$alertClass = "notice-error";
				}
				$panelBox = '<div class="panelnotice '.$alertClass.'"><strong>اطلاعات پنل پیامک</strong><br><br>';
				$panelBox .= '<strong>اعتبار پنل: </strong><span>'.$credit.' </span><br>';
				$panelBox .= '</div><style>
.panelnotice {
    background: #fff;
    border: 1px solid #ccd0d4;
    border-top-width: 4px;
    box-shadow: 0 1px 1px rgba(0,0,0,.04);
    padding: 10px;
}
.panelnotice.notice-info {
    border-top-color: #00a0d2;
}
.panelnotice.notice-warning {
    border-top-color: #ffb900;
}
.panelnotice.notice-error {
    border-top-color: #dc3232;
}
</style>';
		}
		$data['smsirv2_panel_data'] = $panelBox;

		$templates = $this->_smsir_module->getTemplates($data);

		$data['templates'] = array();

		$this->load->model('localisation/order_status');
		$this->load->model('setting/store');

		foreach ($templates as $template) {
			$action = array();

			$action[] = array(
				'link'		=> $this->url->link('extension/module/smsirv2/update', 'user_token=' . $this->session->data['user_token'] . $url . '&template_id=' . $template['sms_template_id'], true),
				'name'		=> $this->language->get('text_edit_template')
			);

			$type = $this->model_localisation_order_status->getOrderStatus($template['type']);

			if ($type) {
				$type = $this->language->get('text_status') . ' ' . $type['name'];
			} else {
				$type = $this->language->get('text_' . $template['type']);
			}

			if ($template['store_id']) {
				$store = $this->model_setting_store->getStore($template['store_id']);
				$store = $store['name'];
			} else {
				$store = $this->language->get('text_default');
			}

			$data['templates'][] = array(
				'sms_template_id'		=> $template['sms_template_id'],
				'name'					=> $template['name'],
				'type'					=> $type,
				'store'					=> $store,
				'selected'     			=> isset($this->request->post['selected']) && in_array($template['sms_template_id'], $this->request->post['selected']),
				'action'				=> $action
			);
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		$pagination = new Pagination();
		$pagination->total = $this->_smsir_module->getTotalTemplates();
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_admin_limit');
		$pagination->text = $this->language->get('text_pagination');
		$pagination->url = $this->url->link('extension/module/phe', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['sort'] = $sort;
		$data['order'] = $order;

		if ($order == 'ASC') {
			$order = 'DESC';
		} else {
			$order = 'ASC';
		}

		$url = '';

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['sort_name'] = $this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'] . '&sort=name&order=' . $order . $url, true);
		$data['sort_type'] = $this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'] . '&sort=type&order=' . $order . $url, true);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
		/*Send to all page*/
		$this->load->model('customer/customer');
		$this->load->model('customer/customer_group');
		$allCustomers = $this->model_customer_customer->getCustomers();
		$customerGroups = $this->model_customer_customer_group->getCustomerGroups();
		$data['all_customers_count'] = $this->model_customer_customer->getTotalCustomers();
		$data['customers_group_options'] = '';
		foreach($customerGroups as $group){
			$data['customers_group_options'] .= '<option value="'.$group['customer_group_id'].'">'.$group['name'].'</option>';
		}
		$data['customers_options'] = '<option value="1">تمام مشتریان (تعداد: '.count($allCustomers).')</option>';

		$this->response->setOutput($this->load->view('extension/module/smsirv2_list', $data));
	}

	/* تهیه فرم قالب */
	protected function getForm() {
		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], true)
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'], true)
   		);

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['tab_general'] = $this->language->get('tab_general');

		$data['entry_type'] = $this->language->get('entry_type');
		$data['entry_store'] = $this->language->get('entry_store');
		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_country'] = $this->language->get('entry_country');
		$data['entry_message'] = $this->language->get('entry_message');
		$data['entry_adminmessage'] = $this->language->get('entry_adminmessage');
		$data['entry_bcc'] = $this->language->get('entry_bcc');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_register'] = $this->language->get('text_register');
		$data['text_affiliate'] = $this->language->get('text_affiliate');
		$data['text_order'] = $this->language->get('text_order');
		$data['text_contact'] = $this->language->get('text_contact');
		$data['text_forgotten'] = $this->language->get('text_forgotten');
		$data['text_reward'] = $this->language->get('text_reward');
		$data['text_account_approve'] = $this->language->get('text_account_approve');
		$data['text_account_transaction'] = $this->language->get('text_account_transaction');
		$data['text_affiliate_approve'] = $this->language->get('text_affiliate_approve');
		$data['text_affiliate_transaction'] = $this->language->get('text_affiliate_transaction');
		$data['text_gift_voucher'] = $this->language->get('text_gift_voucher');
		$data['text_status'] = $this->language->get('text_status');
		$data['text_code'] = $this->language->get('text_code');
		$data['text_default'] = $this->language->get('text_default');
		$data['text_select_all'] = $this->language->get('text_select_all');
		$data['text_unselect_all'] = $this->language->get('text_unselect_all');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->request->get['template_id'])) {
			$data['action'] = $this->url->link('extension/module/smsirv2/update', 'user_token=' . $this->session->data['user_token'] . $url . '&template_id=' . $this->request->get['template_id'], true);
		} else {
			$data['action'] = $this->url->link('extension/module/smsirv2/insert', 'user_token=' . $this->session->data['user_token'] . $url, true);
		}

		$data['cancel'] = $this->url->link('extension/module/smsirv2', 'user_token=' . $this->session->data['user_token'] . $url, true);
		$data['user_token'] = $this->session->data['user_token'];

		if (isset($this->request->get['template_id'])) {
			$template_info = $this->_smsir_module->getTemplate($this->request->get['template_id']);
		} else {
			$template_info = '';
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($template_info)) {
			$data['name'] = $template_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset($this->request->post['type'])) {
			$data['type'] = $this->request->post['type'];
		} elseif (!empty($template_info)) {
			$data['type'] = $template_info['type'];
		} else {
			$data['type'] = '';
		}

		$this->load->model('setting/store');

		$data['stores'] = $this->model_setting_store->getStores();

		if (isset($this->request->post['store_id'])) {
			$data['store_id'] = $this->request->post['store_id'];
		} elseif (!empty($template_info)) {
			$data['store_id'] = $template_info['store_id'];
		} else {
			$data['store_id'] = '';
		}

		if (isset($this->request->post['bcc'])) {
			$data['bcc'] = $this->request->post['bcc'];
		} elseif (!empty($template_info)) {
			$data['bcc'] = $template_info['bcc'];
		} else {
			$data['bcc'] = '';
		}

		if (isset($this->request->post['country'])) {
			$data['country'] = $this->request->post['country'];
		} else {
			$data['country'] = array();
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['description'])) {
			$data['description'] = $this->request->post['description'];
		} elseif (!empty($template_info)) {
			$data['description'] = $template_info['description'];
		} else {
			$data['description'] = array();
		}

		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		$this->load->model('localisation/country');

		$data['countries'] = $this->model_localisation_country->getCountries();

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/smsirv2_form', $data));
	}
	/* دستور ذخیره تنظیمات */
	public function config() {
		if ($this->validateDelete()) {
			$output = array();
			$this->load->model('setting/setting');
			$this->load->model($this->_module_path);
			$this->model_setting_setting->editSetting('smsirv2', $this->request->post);
			$this->model_setting_setting->editSetting('module', array('module_smsirv2_status'=>'1'));
			$credit = $this->_smsir_module->getCredit($this->request->post['smsirv2_api_key']);
			/*if(is_numeric($credit)){
				$output['result'] = 'true';
				$output['panelcredit'] = $credit;
			} else {
				$output['result'] = 'false';
				$output['panelcredit'] = 'امکان بررسی اعتبار شما از پنل پیامک نیست. خطای درگاه: '.$credit;
			}
			$this->response->addHeader('Content-Type: application/json');*/
			$this->response->setOutput($credit);
		}
    }

	/* دستور ارزیابی فرم */
	protected function validateForm() {
		if (!$this->user->hasPermission('modify', 'extension/module/smsirv2')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (empty($this->request->post['name'])) {
			$this->error['warning'] = $this->language->get('error_name');
		}

		return !$this->error;
	}
	/* دستور ارزیابی امکان حذف قالب */
	protected function validateDelete() {
		if (!$this->user->hasPermission('modify', 'extension/module/smsirv2')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
	/* دستور نصب افزونه */
	public function install() {
		if (!$this->user->hasPermission('modify', 'extension/extension/module')) {
			return;
		}

		$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "smsirv2_template` (
		  `sms_template_id` int(11) NOT NULL AUTO_INCREMENT,
		  `type` varchar(255) NOT NULL,
		  `store_id` int(11) NOT NULL,
		  `name` varchar(32) NOT NULL,
		  `bcc` varchar(255) NOT NULL,
		  PRIMARY KEY (`sms_template_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=11 ;");

		$this->db->query("CREATE TABLE `" . DB_PREFIX . "smsirv2_template_message` (
		  `sms_template_id` int(11) NOT NULL,
		  `language_id` int(11) NOT NULL,
		  `otp_send` int(1) NOT NULL,
          `message` text NULL,
		  `message_number` text NULL,
		  `admin_otp_send` int(1) NOT NULL,
		  `adminmessage` text NULL,
		  `adminmessage_number` text NULL
		) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

		$this->db->query("INSERT INTO `" . DB_PREFIX . "smsirv2_template` (`sms_template_id`, `type`, `store_id`, `name`, `bcc`) VALUES
			(1, 'register', 0, 'ثبت نام کاربر (پیش فرض)', ''),
			(2, 'affiliate', 0, 'ثبت نام بازاریاب (پیش فرض)', ''),
			(3, 'order', 0, 'تأیید سفارش (پیش فرض)', ''),
			(4, 'forgotten', 0, 'فراموشی رمز عبور (پیش فرض)', ''),
			(5, 'reward', 0, 'افزودن جایزه (پیش فرض)', ''),
			(6, 'account_approve', 0, 'تأیید حساب مشتری (پیش فرض)', ''),
			(7, 'account_transaction', 0, 'افزودن اعتبار (پیش فرض)', ''),
			(8, 'affiliate_approve', 0, 'تأیید بازاریاب (پیش فرض)', ''),
			(9, 'affiliate_transaction', 0, 'افزودن کمیسیون بازاریاب (پیش فرض)', ''),
			(10, '2', 0, 'در حال پردازش (پیش فرض)', '');
		");
		$this->db->query("INSERT INTO `" . DB_PREFIX . "setting` (`store_id`, `code`, `key`, `value`, `serialized`) VALUES ('0', 'smsirv2', 'smsirv2_domain', 'https://smsirv2.com', '0')");
		$this->db->query("INSERT INTO `" . DB_PREFIX . "smsirv2_template_message` (`sms_template_id`, `language_id`, `message`) VALUES
			(1, 1, '{firstname} گرامی\r\n به " . $this->config->get('config_name') . ". خوش آمدید.\r\n " . HTTPS_CATALOG . "'),
			(2, 1, '{firstname} گرامی\r\nاز اینکه به بازاریابان " . $this->config->get('config_name') . " پیوستید تشکر می کنیم. پس از تأیید بازاریابی شما مجددا به شما اطلاع می دهیم.'),
			(3, 1, '{firstname} گرامی سلام,\r\n\r\nسفارش شما به شماره #{order_id} دریافت شد و پس از تأیید پرداخت پردازش خواهد شد.'),
			(4, 1, '{firstname} گرامی سلام\r\n\r\nیک درخواست بازیابی رمز عبور برای حساب کاربری شما در " . $this->config->get('config_name') . " دریافت شده است. اگر این درخواست از طرف شما نیست در اسرع وقت به ما اطلاع دهید و رمز عبور خود را تغییر دهید.\r\n" . HTTPS_CATALOG . "'),
			(5, 1, '{firstname} گرامی\r\n\r\nشما {points} امتیاز به عنوان پاداش دریافت کردید!\r\nشما می توانید این امتیاز را در فروشگاه ما خرج کنید. در حال حاضر جمعاً {total_points} امتیاز دارید.\r\n" . $this->config->get('config_name') . "'),
			(6, 1, '{firstname} سلام,\r\n\r\nحساب کاربری شما تأیید شد و شما می توانید با ایمیل و رمز عبور خود وارد سایت ما شوید.\r\n" . HTTPS_CATALOG . "'),
			(7, 1, '{firstname} سلام\r\n\r\nشما به میزان {credits} اعتبار در حساب خود دریافت کردید و می توانید در فروشگاه از آن استفاده نمایید. در حال حاضر جمعاً {total_credits} اعتبار در سایت دارید.'),
			(8, 1, '{firstname} سلام\r\n\r\nحساب بازاریابی شما تأیید شد و شما می توانید با ایمیل و رمزعبور خود وارد سایت شوید\r\n" . HTTPS_CATALOG . ".'),
			(9, 1, '{firstname} سلام\r\n\r\nشما مقدار {commission} کمیسیون دریافت کردید! جمع کمیسیون دریافتی شما در حال حاضر {total_commission} می باشد.'),
			(10, 1, '{firstname} عزیز\r\n\r\nدر حال حاضر ما در حال پردازش سفارش شما به شماره #{order_id} می باشیم.');
		");

		$this->db->query("INSERT INTO `" . DB_PREFIX . "smsirv2_template_message` (`sms_template_id`, `language_id`, `message`) VALUES
			(1, 2, '{firstname} گرامی\r\n به " . $this->config->get('config_name') . ". خوش آمدید.\r\n " . HTTPS_CATALOG . "'),
			(2, 2, '{firstname} گرامی\r\nاز اینکه به بازاریابان " . $this->config->get('config_name') . " پیوستید تشکر می کنیم. پس از تأیید بازاریابی شما مجددا به شما اطلاع می دهیم.'),
			(3, 2, '{firstname} گرامی سلام,\r\n\r\nسفارش شما به شماره #{order_id} دریافت شد و پس از تأیید پرداخت پردازش خواهد شد.'),
			(4, 2, '{firstname} گرامی سلام\r\n\r\nیک درخواست بازیابی رمز عبور برای حساب کاربری شما در " . $this->config->get('config_name') . " دریافت شده است. اگر این درخواست از طرف شما نیست در اسرع وقت به ما اطلاع دهید و رمز عبور خود را تغییر دهید.\r\n" . HTTPS_CATALOG . "'),
			(5, 2, '{firstname} گرامی\r\n\r\nشما {points} امتیاز به عنوان پاداش دریافت کردید!\r\nشما می توانید این امتیاز را در فروشگاه ما خرج کنید. در حال حاضر جمعاً {total_points} امتیاز دارید.\r\n" . $this->config->get('config_name') . "'),
			(6, 2, '{firstname} سلام,\r\n\r\nحساب کاربری شما تأیید شد و شما می توانید با ایمیل و رمز عبور خود وارد سایت ما شوید.\r\n" . HTTPS_CATALOG . "'),
			(7, 2, '{firstname} سلام\r\n\r\nشما به میزان {credits} اعتبار در حساب خود دریافت کردید و می توانید در فروشگاه از آن استفاده نمایید. در حال حاضر جمعاً {total_credits} اعتبار در سایت دارید.'),
			(8, 2, '{firstname} سلام\r\n\r\nحساب بازاریابی شما تأیید شد و شما می توانید با ایمیل و رمزعبور خود وارد سایت شوید\r\n" . HTTPS_CATALOG . ".'),
			(9, 2, '{firstname} سلام\r\n\r\nشما مقدار {commission} کمیسیون دریافت کردید! جمع کمیسیون دریافتی شما در حال حاضر {total_commission} می باشد.'),
			(10, 2, '{firstname} عزیز\r\n\r\nدر حال حاضر ما در حال پردازش سفارش شما به شماره #{order_id} می باشیم.');
		");

		$this->load->model('setting/event');

		$this->model_setting_event->addEvent('module_smsirv2', 'catalog/model/account/customer/addCustomer/after', 'extension/module/smsirv2/eventPostModelAccountCustomerAdd');
		$this->model_setting_event->addEvent('module_smsirv2', 'catalog/model/account/customer/addAffiliate/after', 'extension/module/smsirv2/eventPostModelAccountCustomerAddAffiliate');
		$this->model_setting_event->addEvent('module_smsirv2', 'catalog/model/account/customer/addTransaction/after', 'extension/module/smsirv2/eventPostModelAccountCustomerAddTransaction');
		$this->model_setting_event->addEvent('module_smsirv2', 'catalog/model/account/customer/editCode/after', 'extension/module/smsirv2/eventPostModelAccountCustomerEditCode');
		$this->model_setting_event->addEvent('module_smsirv2', 'catalog/model/checkout/order/addOrderHistory/before', 'extension/module/smsirv2/eventPreModelCheckoutOrderAddOrderHistory');
		$this->model_setting_event->addEvent('module_smsirv2', 'admin/model/customer/customer/addReward/after', 'extension/module/smsirv2/eventPostModelCustomerCustomerAddReward');
		$this->model_setting_event->addEvent('module_smsirv2', 'admin/model/customer/customer/addTransaction/after', 'extension/module/smsirv2/eventPostModelCustomerCustomerAddTransaction');
		$this->model_setting_event->addEvent('module_smsirv2', 'admin/model/customer/customer_approval/approveCustomer/after', 'extension/module/smsirv2/eventPostModelCustomerCustomerApprovalApproveCustomer');
		$this->model_setting_event->addEvent('module_smsirv2', 'admin/model/customer/customer_approval/approveAffiliate/after', 'extension/module/smsirv2/eventPostModelCustomerCustomerApprovalApproveAffiliate');
	}
	/* دستور غیرفعال سازی افزونه */
	public function uninstall() {
		if (!$this->user->hasPermission('modify', 'extension/extension/module')) {
			return;
		}

		$this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "smsirv2_template");
		$this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "smsirv2_template_message");
		$this->db->query("DELETE FROM " . DB_PREFIX . "setting WHERE `code` = 'smsirv2'");
		$this->db->query("UPDATE " . DB_PREFIX . "setting SET `value` = 0 WHERE `key` = 'module_smsirv2_status'");

		$this->load->model('setting/event');

		$this->model_setting_event->deleteEventByCode('module_smsirv2');
	}
	/* رویداد افزودن جایزه */
	public function eventPostModelCustomerCustomerAddReward($route, $args, $output) {
		$this->load->model('customer/customer');
		$this->load->model($this->_module_path);

		$customer_id = isset($args[0]) ? $args[0] : 0;
		$description = isset($args[1]) ? $args[1] : '';
		$points = isset($args[2]) ? $args[2] : 0;
		$order_id = isset($args[3]) ? $args[3] : 0;

		$customer_info = $this->model_customer_customer->getCustomer($customer_id);

		$replace = array(
			'firstname' => $customer_info['firstname'],
            'lastname' => $customer_info['lastname'],
            'email' => $customer_info['email'],
            'points' => $points,
            'total_points' => $this->model_customer_customer->getRewardTotal($customer_id)
		);

		if ($order_id) {
			$this->load->model('sale/order');

			$order_info = $this->model_sale_order->getOrder($order_id);

			$store_id = $order_info['store_id'];
		} else {
			$store_id = $customer_info['store_id'];
		}

		$this->_smsir_module->parseSMS('reward', $store_id, $customer_info['telephone'], $replace);
	}
	/* رویداد افزودن معامله */
	public function eventPostModelCustomerCustomerAddTransaction($route, $args, $output) {
		$this->load->model('customer/customer');
		$this->load->model($this->_module_path);

		$customer_id = isset($args[0]) ? $args[0] : 0;
		$description = isset($args[1]) ? $args[1] : '';
		$amount = isset($args[2]) ? $args[2] : 0;
		$order_id = isset($args[3]) ? $args[3] : 0;

		$customer_info = $this->model_customer_customer->getCustomer($customer_id);

		$replace = array(
            'firstname' => $customer_info['firstname'],
            'lastname' => $customer_info['lastname'],
            'email' => $customer_info['email'],
            'credits' => $this->currency->format($amount, $this->config->get('config_currency')),
            'total_credits' => $this->currency->format($this->model_customer_customer->getTransactionTotal($customer_id), $this->config->get('config_currency'))
		);

		if ($order_id) {
			$this->load->model('sale/order');

			$order_info = $this->model_sale_order->getOrder($order_id);

			$store_id = $order_info['store_id'];
		} else {
			$store_id = $customer_info['store_id'];
		}

		$this->_smsir_module->parseSMS('account_transaction', $store_id, $customer_info['telephone'], $replace);
	}
	/* رویداد تأیید کاربر */
	public function eventPostModelCustomerCustomerApprovalApproveCustomer($route, $args, $output) {
		$this->load->model('customer/customer');
		$this->load->model($this->_module_path);

		$customer_info = $this->model_customer_customer->getCustomer($args[0]);

		$replace = array(
            'firstname' => $customer_info['firstname'],
            'lastname' => $customer_info['lastname'],
            'email' => $customer_info['email']
		);

		$this->_smsir_module->parseSMS('account_approve', $customer_info['store_id'], $customer_info['telephone'], $replace);
	}
	/* رویداد تأیید بازاریاب */
	public function eventPostModelCustomerCustomerApprovalApproveAffiliate($route, $args, $output) {
		$this->load->model('customer/customer');
		$this->load->model($this->_module_path);

		$customer_info = $this->model_customer_customer->getCustomer($args[0]);

		$replace = array(
            'firstname' => $customer_info['firstname'],
            'lastname' => $customer_info['lastname'],
            'email' => $customer_info['email']
		);

		$this->_smsir_module->parseSMS('affiliate_approve', $this->config->get('config_store_id'), $customer_info['telephone'], $replace);
	}
}
