<?php

/**
 * @package Sms.ir v2 opencart package
 * @author Pouya Biglari (cyberman9000@gmail.com)
 * @copyright sms.ir
 * @version 1.0.0
 */
class ModelExtensionModulesmsirv2 extends Model {

    private $_call_model = 'model_extension_module_smsirv2';
    private $_module_path = 'extension/module/smsirv2';
    private $_smsir_module;

    public function __construct($registry) {
        parent::__construct($registry);
        if (version_compare(VERSION, '2.3.0.0', '<')) {
            $this->_module_path = 'module/smsir';
        }
        $this->_smsir_module = $this->{$this->_call_model};
    }

    /**
     * افزودن تیک ارسال پیامک در صفحه تغییر وضعیت سفارش
     */
    public function smsirv2_order_checkbox($css_class_left = "col-sm-2", $css_class_right = "col-sm-10") {

        $this->load->language($this->_module_path);
        $data['smsirv2_entry_notify_by_sms_label'] = $this->language->get('smsirv2_entry_notify_by_sms_label');

         $data['css_class_left']  = $css_class_left;
         $data['css_class_right'] = $css_class_right;
		return $this->load->view('extension/module/smsirv2_orderinfo_checkbox', $data);
    }


    /**
     * بررسی درخواست ارسال پیامک توسط کاربر در صفحه سفارش
     */
    public function build_request_params_in_order_status_update_ajax_request(){

        /*
         *  + '&notify_by_sms=' + ($('input[name=\'notify_by_sms\']').prop('checked') ? 1 : 0) + '&notify=' +
         */
        $params = "'&notify_by_sms=' + ($('input[name=\'notify_by_sms\']').prop('checked') ? 1 : 0)" ;

        return $params;
    }
	/* افزودن قالب به دیتابیس*/
	public function addTemplate($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "smsirv2_template SET store_id = '" . (int)$data['store_id'] . "', type = '" . $this->db->escape($data['type']) . "', name = '" . $this->db->escape($data['name']) . "', bcc = '" . $this->db->escape($data['bcc']) . "'");

		$template_id = $this->db->getLastId();

		foreach ($data['description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "smsirv2_template_message SET sms_template_id = '" . (int)$template_id . "', language_id = '" . (int)$language_id . "', message = '" . $this->db->escape($value['message']) . "', adminmessage = '" . $this->db->escape($value['adminmessage']) . "'");
		}
	}
	/* ورود ویرایش قالب در دیتابیس*/
	public function editTemplate($template_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "smsirv2_template SET store_id = '" . (int)$data['store_id'] . "', type = '" . $this->db->escape($data['type']) . "', name = '" . $this->db->escape($data['name']) . "', bcc = '" . $this->db->escape($data['bcc']) . "' WHERE sms_template_id = '" . (int)$template_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "smsirv2_template_message WHERE sms_template_id = '" . (int)$template_id . "'");

		foreach ($data['description'] as $language_id => $value) {
			$this->db->query(
                "INSERT INTO " . DB_PREFIX . "smsirv2_template_message".
                " SET sms_template_id = '" . (int)$template_id .
                "', language_id = '" . (int)$language_id .
                "', otp_send = '" . (int)$value['otp_send'] .
                "', message = '" . $this->db->escape($value['message']) .
                "', message_number = '" . $this->db->escape($value['message_number']) .
                "', admin_otp_send = '" . (int)$value['admin_otp_send'] .
                "', adminmessage = '" . $this->db->escape($value['adminmessage']) .
                "', adminmessage_number = '" . $this->db->escape($value['adminmessage_number']) . "'");
		}
	}
	/* حذف قالب از دیتابیس*/
	public function deleteTemplate($template_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsirv2_template WHERE sms_template_id = '" . (int)$template_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "smsirv2_template_message WHERE sms_template_id = '" . (int)$template_id . "'");
	}
	/* دریافت  یک قالب از دیتابیس*/
	public function getTemplate($template_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsirv2_template WHERE sms_template_id = '" . (int)$template_id . "'");

		if ($query->num_rows) {
			$description = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsirv2_template_message WHERE sms_template_id = '" . (int)$template_id . "'");

			$description_data = array();

			foreach ($description->rows as $description) {
				$description_data[$description['language_id']] = array(
					'otp_send'		=> $description['otp_send'],
					'message'		=> $description['message'],
					'message_number'		=> $description['message_number'],
					'admin_otp_send'		=> $description['admin_otp_send'],
					'adminmessage'		=> $description['adminmessage'],
					'adminmessage_number'		=> $description['adminmessage_number']
				);
			}

			return array(
				'sms_template_id'	=> $query->row['sms_template_id'],
				'type'				=> $query->row['type'],
				'store_id'			=> $query->row['store_id'],
				'name'				=> $query->row['name'],
				'bcc'				=> $query->row['bcc'],
				'description'		=> $description_data
			);
		} else {
			return false;
		}
	}
	/* دریافت همه قالب ها از دیتابیس */
	public function getTemplates($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "smsirv2_template";

		$sort_data = array(
			'name',
			'type'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}
	/* دریافت تعداد قالب ها از دیتابیس*/
	public function getTotalTemplates() {
      	$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "smsirv2_template");

		return $query->row['total'];
	}
	/* دریافت متن پیامک قالب ها از دیتابیس */
	private function getSMSTemplates($type, $store_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsirv2_template st LEFT JOIN " . DB_PREFIX . "smsirv2_template_message stm ON st.sms_template_id = stm.sms_template_id WHERE type = '" . $this->db->escape($type) . "' AND store_id = '" . (int)$store_id . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'");

		return $query->rows;
	}
	/* جستجوی متغیرها در متن پیامک */
	private function getSearch($type) {
		if ($type == 'register') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{commission}',
				'{total_commission}'
			);
		} elseif ($type == 'affiliate_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'forgotten') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{password}'
			);
		} elseif ($type == 'order') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		} elseif ($type == 'reward') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{points}',
				'{total_points}'
			);
		} elseif ($type == 'account_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'account_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{credits}',
				'{total_credits}'
			);
		} else {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		}

		return $search;
	}
	/* جایگذاری مقدار متغیرهای پیامک و ارسال پیامک */
	public function parseSMS($type, $store_id, $number, $replace) {
		$number = preg_replace('/[^0-9]/', '', $number);
		if($type == 'send_sms'){
			$this->sendSMS($number, $replace);
		}else{
			$templates = $this->getSMSTemplates($type, $store_id);
			$template_data = false;
			foreach ($templates as $template) {
				$template_data = $template;
			}

			if ($template_data && !empty($template_data['message'])) {
				$search = $this->getSearch($type);

				$message = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['message'])));

				$this->sendSMS($number, $message);
				if($template_data['bcc'] && !empty($template_data['adminmessage'])){
					$numbers = explode(',', $template_data['bcc']);
					$adminmessage = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['adminmessage'])));
					foreach ($numbers as $number) {
						$this->sendSMS($number, $adminmessage);
					}
				}
			} else {
				return false;
			}
		}
	}
	/* ارسال پیامک به وب سرویس */
	public function sendSMS($receiver = null, $message = null, $otp_send = false, $likeToLike = false) {
		$response = false;
		$username = $this->config->get('smsirv2_username');
		$password = $this->config->get('smsirv2_api_key');
		$from     = $this->config->get('smsirv2_line_number');
		$debug    = $this->config->get('smsirv2_debug');
		if ($debug == 1) {
			$result = "SMS DEBUG(admin): Reciver: {$receiver} - message : {$message}";
			error_log($result);
			$this->log->write($result);
			$this->session->data['success'] = $result;
			return $result;
		}
		if ( empty( $username ) || empty( $password ) || empty( $from ) ||  empty( $receiver ) ||  (empty( $message ) && !$otp_send) ) {
			return $response;
		}
        if ($otp_send){
            $url = '/send/verify';
            $params = [
                'mobile' => $receiver,
                'templateId' => $otp_send,
                'parameters' => [
                    $message
                ]
            ];
        }else if ($likeToLike){
            $url = "/send/likeToLike";
            $params = [
                'lineNumber' => $from,
                'messageTexts' => $message,
                'Mobiles' => $receiver,
            ];
        } else {
            $url = "/send/bulk";
            $params = [
                'lineNumber' => $from,
                'messageText' => $message,
                'mobiles' => [$receiver],
            ];
        }
        $result = $this->cUrl( $url, $params, 'POST');
        $response = json_decode($result);
        if ($response-> status == 1) {
            return true;
        }else{
            $this->log->write($this->getErrors($response->status));
            $this->session->data['warning'] = $this->getErrors($response->status);
            error_log($response->status . ':' .$this->getErrors($response->status));
            return $response->status . ':' .$this->getErrors($response->status);
		}
	}
	/* چک کردن پترن از وب سرویس*/
	public function checkPattern($patternCode = null){

		if($patternCode){
			$params = array(
				'uname' => trim($this->config->get('smsirv2_username')),
				'pass'  => trim($this->config->get('smsirv2_password')),
				'patternCode'=> trim($patternCode),
				'op'=> 'getPatternParams',
			);
			$url = "/api/select";
			$result = $this->cUrl( $url, json_encode($params), 'POST' );
			$response = json_decode($result,true);
			if (is_array($response) && isset($response['status']['code'])) {
				$status = $response['status']['code'];
				if($status == 0){
					$patternMessage = $response['data']['patternMessage'];
					$patternParams = $response['data']['patternParams'];
					$result = array('status'=>$status,'message'=>$patternMessage,'vars'=>$patternParams);
				} else {
					$result = array('status'=>$status,'message'=>$this->getErrors($status));
				}
			}else{
				$result = array('status'=>-1,'message'=>'اشکالی در دریافت اطلاعات پترن به وجود آمد.');
			}
			return $result;
		}else{
			return '-1';
		}
		die();
	}

	/* دریافت باقیمانده اعتبار از وب سرویس */
	public function getCredit($api_key = null) {
		$url = "/credit";
		$result = $this->cUrl( $url, array(), 'GET');
		$response = json_decode($result);
		$res_code = $response->status;
		$res_data = $response->data;
		if ($res_code == '1'){
			return round($res_data);
		}
        return $this->getErrors($res_code);
    }

	/* دستور ارتباط با وب سرویس سامانه پیامک*/
	private function cUrl( $url, $params = array(), $method = 'POST', $headers = array()) {
        $api_key = $this->config->get('smsirv2_api_key');
        $headers[] = 'X-API-KEY: '. $api_key;
        $headers[] = 'Content-Type:application/json';
		$domain = "https://api.sms.ir/v1";
		$handler = curl_init($domain.$url);
		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($handler, CURLOPT_TIMEOUT, 20);
		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, $method);
        curl_setopt($handler, CURLOPT_HTTPHEADER, $headers);
		if($method == 'POST') curl_setopt($handler, CURLOPT_POSTFIELDS, json_encode($params));
		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($handler);
		return $result;
	}

	/* لیست خطاهای وب سرویس*/
	private function getErrors($error){
		$errorCodes = array(
            '1'  => 'عملیات با موفقیت انجام شده است.',
            '0'  => 'مشکلی در سامانه رخ داده است، لطفا با پشتیبانی در تماس باشید',
            '10'  => 'کلید وب سرویس نامعتبر است',
            '11'  => 'کلید وب سرویس غیرفعال است',
            '12'  => 'کلید وب‌ سرویس محدود به IP‌های تعریف شده می‌باشد',
            '13'  => 'حساب کاربری غیر فعال است',
            '14'  => 'حساب کاربری در حالت تعلیق قرار دارد',
            '20'  => 'تعداد درخواست بیشتر از حد مجاز است',
            '101'  => 'شماره خط نامعتبر می‌باشد',
            '102'  => 'اعتبار کافی نمی‌باشد',
            '103'  => 'درخواست شما دارای متن (های) خالی است',
            '104'  => 'درخواست شما دارای موبایل (های) نادرست است',
            '105'  => 'تعداد موبایل ها بیشتر از حد مجاز (100 عدد) می‌باشد',
            '106'  => 'تعداد متن ها بیشتر از حد مجاز (100 عدد) می‌باشد',
            '107'  => 'لیست موبایل ها خالی می‌باشد',
            '108'  => 'لیست متن ها خالی می‌باشد',
            '109'  => 'زمان ارسال نامعتبر می‌باشد',
            '110'  => 'تعداد شماره موبایل‌ها و تعداد متن ها برابر نیستند',
            '111'  => 'با این شناسه ارسالی ثبت نشده است',
            '112'  => 'رکوردی برای حذف یافت نشد',
            '113'  => 'قالب یافت نشد',
            '114'  => 'طول رشته مقدار پارامتر، بیش از حد مجاز (64 کاراکتر) می‌باشد',
            '115'  => 'شماره موبایل(ها) در لیست سیاه سامانه می‌باشند',
		);
		return (isset($errorCodes[$error])) ? $errorCodes[$error] : 'اشکال تعریف نشده با کد :' . $error;
	}
}
