<?php
class ControllerExtensionModulesmsirv2 extends Controller {
	/* رویداد ثبت نام کاربر */
	public function eventPostModelAccountCustomerAdd($route, $args, $output) {
		$this->load->model('account/customer');
		$this->load->model('extension/module/smsirv2');

        $this->log->write('smsirv2 1');
		$customer_info = $this->model_account_customer->getCustomer($output);

		$replace = array(
			'firstname' => $customer_info['firstname'],
			'lastname' => $customer_info['lastname'],
			'email' => $customer_info['email'],
			'telephone' => $customer_info['telephone'],
			'password' => $args[0]['password']
		);
        $this->log->write('smsirv2 2');
		$this->model_extension_module_smsirv2->parseSMS('register', $this->config->get('config_store_id'), $customer_info['telephone'], $replace);
	}
	/* رویداد ثبت نام بازاریابت */
	public function eventPostModelAccountCustomerAddAffiliate($route, $args, $output) {
		$this->load->model('account/customer');
		$this->load->model('extension/module/smsirv2');

		$customer_info = $this->model_account_customer->getCustomer($args[0]);

		$replace = array(
            'firstname' => $customer_info['firstname'],
            'lastname' => $customer_info['lastname'],
            'email' => $customer_info['email'],
            'telephone' => $customer_info['telephone'],
            'password' => $args[0]['password']
		);

		$this->model_extension_module_smsirv2->parseSMS('affiliate', $this->config->get('config_store_id'), $customer_info['telephone'], $replace);
	}
	/* رویداد افزودن معامله */
	public function eventPostModelAccountCustomerAddTransaction($route, $args, $output) {
		$this->load->model('account/customer');
		$this->load->model('extension/module/smsirv2');

		$customer_id = isset($args[0]) ? $args[0] : 0;
		$description = isset($args[1]) ? $args[1] : '';
		$amount = isset($args[2]) ? $args[2] : 0;
		$order_id = isset($args[3]) ? $args[3] : 0;

		$customer_info = $this->model_account_customer->getCustomer($customer_id);

		$replace = array(
            'firstname' => $customer_info['firstname'],
            'lastname' => $customer_info['lastname'],
            'email' => $customer_info['email'],
			'commission' => $this->currency->format($amount, $this->config->get('config_currency')),
			'total_commission' => $this->currency->format($this->model_account_customer->getTransactionTotal($customer_id), $this->config->get('config_currency'))
		);

		$this->model_extension_module_smsirv2->parseSMS('affiliate_transaction', $this->config->get('config_store_id'), $customer_info['telephone'], $replace);
	}
	/* رویداد بازیابی رمز عبور */
	public function eventPostModelAccountCustomerEditCode($route, $args, $output) {
		$this->load->model('account/customer');
		$this->load->model('extension/module/smsirv2');

		$customer_info = $this->model_account_customer->getCustomerByEmail($args[0]);
		$pass = rand(1111111,9999999);
		$code = token(40);
		$resetlink = $this->url->link('account/reset', 'code=' . $code, true);
		$replace = array(
            'firstname' => $customer_info['firstname'],
            'lastname' => $customer_info['lastname'],
            'email' => $customer_info['email'],
		);
		if($this->config->get('smsirv2_forgotten') == 0 ){
			$this->db->query("UPDATE `" . DB_PREFIX . "customer` SET code = '" . $this->db->escape($code) . "' WHERE LCASE(email) = '" . $this->db->escape(utf8_strtolower($customer_info['email'])) . "'");
			$replace[] = $resetlink;

		} else {
			$this->model_account_customer->editPassword($customer_info['email'], $pass);
			$replace[] = $pass;
		}
		return $this->model_extension_module_smsirv2->parseSMS('forgotten', $this->config->get('config_store_id'), $customer_info['telephone'], $replace);
	}
	/* رویداد افزودن تاریخچه سفارش */
	public function eventPreModelCheckoutOrderAddOrderHistory($route, $args) {
		if (isset($args[0])) {
			$order_id = $args[0];
		} else {
			$order_id = 0;
		}

		if (isset($args[1])) {
			$order_status_id = $args[1];
		} else {
			$order_status_id = 0;
		}

		if (isset($args[2])) {
			$comment = $args[2];
		} else {
			$comment = '';
		}

		if (isset($args[3])) {
			$notify = $args[3];
		} else {
			$notify = '';
		}

		if (isset($args[4])) {
			$notifybysms = $args[4];
		} else {
			$notifybysms = '';
		}

		$order_info = $this->model_checkout_order->getOrder($order_id);

		if ($order_info) {
			// Order confirmation
			if (!$order_info['order_status_id'] && $order_status_id) {
				$this->load->model('extension/module/smsirv2');

				if ($order_info['payment_address_format']) {
					$format = $order_info['payment_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['payment_firstname'],
					'lastname'  => $order_info['payment_lastname'],
					'company'   => $order_info['payment_company'],
					'address_1' => $order_info['payment_address_1'],
					'address_2' => $order_info['payment_address_2'],
					'city'      => $order_info['payment_city'],
					'postcode'  => $order_info['payment_postcode'],
					'zone'      => $order_info['payment_zone'],
					'country'   => $order_info['payment_country']
				);

				$payment_address = trim(str_replace($find, $replace, $format));

				if ($order_info['shipping_address_format']) {
					$format = $order_info['shipping_address_format'];
				} else {
					$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
				}

				$find = array(
					'{firstname}',
					'{lastname}',
					'{company}',
					'{address_1}',
					'{address_2}',
					'{city}',
					'{postcode}',
					'{zone}',
					'{country}'
				);

				$replace = array(
					'firstname' => $order_info['shipping_firstname'],
					'lastname'  => $order_info['shipping_lastname'],
					'company'   => $order_info['shipping_company'],
					'address_1' => $order_info['shipping_address_1'],
					'address_2' => $order_info['shipping_address_2'],
					'city'      => $order_info['shipping_city'],
					'postcode'  => $order_info['shipping_postcode'],
					'zone'      => $order_info['shipping_zone'],
					'country'   => $order_info['shipping_country']
				);

				$shipping_address = trim(str_replace($find, $replace, $format));

				$order_product_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$order_id . "'");

				$plain_product_table = '';

				foreach ($order_product_query->rows as $product) {
					$plain_product_table .= $product['quantity'] . 'x ' . $product['name'] . '(' . $this->currency->format($product['total'] + ($this->config->get('config_tax') ? ($product['tax'] * $product['quantity']) : 0), $order_info['currency_code'], $order_info['currency_value']) . ')' . "\n";

					$order_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$order_id . "' AND order_product_id = '" . (int)$product['order_product_id'] . "'");

					foreach ($order_option_query->rows as $option) {
						$plain_product_table .= '- ' . $option['name'] . ': ' . $option['value'] . "\n";
					}
				}

				$replace = array(
                    'firstname' => $order_info['firstname'],
                    'lastname' => $order_info['lastname'],
                    'email' => $order_info['email'],
                    'telephone' => $order_info['telephone'],
                    'order_id' => $order_info['order_id'],
                    'date_added' => date($this->language->get('date_format_short'), strtotime($order_info['date_added'])),
                    'payment_method' => $order_info['payment_method'],
                    'shipping_method' => $order_info['shipping_method'],
                    'ip' => $order_info['ip'],
                    'order_comment' => $notifybysms ? $comment : '',
                    'payment_address' => trim(str_replace("\n","-",$payment_address)),
                    'shipping_address' => trim(str_replace("\n","-",$shipping_address)),
                    'products' => trim(str_replace("\n","-",$plain_product_table))
				);

				$this->model_extension_module_smsirv2->parseSMS('order', $order_info['store_id'], $order_info['telephone'], $replace);
			}

			// Order update
			if ($order_info['order_status_id'] && $order_status_id && $notifybysms) {
				$this->load->model('extension/module/smsirv2');

				if ($notifybysms) {
					if ($order_info['payment_address_format']) {
						$format = $order_info['payment_address_format'];
					} else {
						$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
					}

					$find = array(
						'{firstname}',
						'{lastname}',
						'{company}',
						'{address_1}',
						'{address_2}',
						'{city}',
						'{postcode}',
						'{zone}',
						'{country}'
					);

					$replace = array(
						'firstname' => $order_info['payment_firstname'],
						'lastname'  => $order_info['payment_lastname'],
						'company'   => $order_info['payment_company'],
						'address_1' => $order_info['payment_address_1'],
						'address_2' => $order_info['payment_address_2'],
						'city'      => $order_info['payment_city'],
						'postcode'  => $order_info['payment_postcode'],
						'zone'      => $order_info['payment_zone'],
						'country'   => $order_info['payment_country']
					);

					$payment_address = trim(str_replace($find, $replace, $format));

					if ($order_info['shipping_address_format']) {
						$format = $order_info['shipping_address_format'];
					} else {
						$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
					}

					$find = array(
						'{firstname}',
						'{lastname}',
						'{company}',
						'{address_1}',
						'{address_2}',
						'{city}',
						'{postcode}',
						'{zone}',
						'{country}'
					);

					$replace = array(
						'firstname' => $order_info['shipping_firstname'],
						'lastname'  => $order_info['shipping_lastname'],
						'company'   => $order_info['shipping_company'],
						'address_1' => $order_info['shipping_address_1'],
						'address_2' => $order_info['shipping_address_2'],
						'city'      => $order_info['shipping_city'],
						'postcode'  => $order_info['shipping_postcode'],
						'zone'      => $order_info['shipping_zone'],
						'country'   => $order_info['shipping_country']
					);

					$shipping_address = trim(str_replace($find, $replace, $format));

					$order_product_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$order_id . "'");

					$plain_product_table = '';

					foreach ($order_product_query->rows as $product) {
						$plain_product_table .= $product['quantity'] . 'x ' . $product['name'] . '(' . $this->currency->format($product['total'] + ($this->config->get('config_tax') ? ($product['tax'] * $product['quantity']) : 0), $order_info['currency_code'], $order_info['currency_value']) . ')' . "\n";

						$order_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$order_id . "' AND order_product_id = '" . (int)$product['order_product_id'] . "'");

						foreach ($order_option_query->rows as $option) {
							$plain_product_table .= '- ' . $option['name'] . ': ' . $option['value'] . "\n";
						}
					}

					$replace = array(
                        'firstname' => $order_info['firstname'],
                        'lastname' => $order_info['lastname'],
                        'email' => $order_info['email'],
                        'telephone' => $order_info['telephone'],
                        'order_id' => $order_info['order_id'],
                        'date_added' => date($this->language->get('date_format_short'), strtotime($order_info['date_added'])),
                        'payment_method' => $order_info['payment_method'],
                        'shipping_method' => $order_info['shipping_method'],
                        'ip' => $order_info['ip'],
                        'order_comment' => $notifybysms ? $comment : '',
                        'payment_address' => trim(str_replace("\n","-",$payment_address)),
                        'shipping_address' => trim(str_replace("\n","-",$shipping_address)),
                        'products' => trim(str_replace("\n","-",$plain_product_table))
					);

					$this->model_extension_module_smsirv2->parseSMS($order_status_id, $order_info['store_id'], $order_info['telephone'], $replace);
				}
			}
		}
	}
}
