<?php
class ModelExtensionModulesmsirv2 extends Model {
	const PATTERN_PHONE	= '/^(\+)?(country_code)?0?\d+$/';
	/* دریافت تمام قالب های پیامکی از دیتابیس */
	private function getTemplates($type, $store_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsirv2_template AS st LEFT JOIN " . DB_PREFIX . "smsirv2_template_message AS stm ON st.sms_template_id = stm.sms_template_id LEFT JOIN " . DB_PREFIX . "language  AS lg ON lg.language_id = stm.language_id WHERE st.type = '" . $this->db->escape($type) . "' AND st.store_id = '" . (int)$store_id . "' AND lg.`code` = '" . $this->config->get('config_language') . "'");
		return $query->rows;
	}
	/* جستجوی متغیرها در متن پیامک ها */
	private function getSearch($type) {
		if ($type == 'register') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{commission}',
				'{total_commission}'
			);
		} elseif ($type == 'affiliate_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'forgotten') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{password}'
			);
		} elseif ($type == 'order') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		} elseif ($type == 'reward') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{points}',
				'{total_points}'
			);
		} elseif ($type == 'account_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'account_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{credits}',
				'{total_credits}'
			);
		} else {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{order_comment}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		}

		return $search;
	}
	/* جایگذاری مقدار متغیرها و ارسال پیامک */
	public function parseSMS($type, $store_id, $number, $replace) {

        $this->log->write('smsirv2 3');
		$number = preg_replace('/[^0-9]/', '', $number);


		$templates = $this->getTemplates($type, $store_id);


        $this->log->write('smsirv2 4');
		$template_data = false;
		foreach ($templates as $template) {
			$template_data = $template;
		}
        if (!$template_data) {

            $this->log->write('smsirv2 -1');
            return false;
        }
        $this->log->write('smsirv2 6');
        if ($template_data['otp_send']) {
            $this->log->write('smsirv2 7 otp user');
            $message = $replace;
            $this->sendSMS($number, $message, $template_data['message_number']);
        } else {
            $this->log->write('smsirv2 user message');
            $search = $this->getSearch($type);
            $message = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['message'])));
            $this->sendSMS($number, $message);
        }

        if ($template_data['admin_otp_send']) {
            $this->log->write('smsirv2 8 otp admin');
            $numbers = explode(',', $template_data['bcc']);
            $message = $replace;
            foreach ($numbers as $number){
                $this->sendSMS($number, $message, $template_data['message_number']);
            }
        } else {
            $this->log->write('smsirv2 admin message parse');
            $numbers = explode(',', $template_data['bcc']);
            $adminmessage = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['adminmessage'])));
            foreach ($numbers as $number) {
                $this->sendSMS($number, $adminmessage);
            }
        }
	}
	/* دستور ارسال پیامک به وب سرویس */
	public function sendSMS($receiver = null, $message = null, $otp_send = false) {
		$response = false;
		$api_key = ($this->config->get('smsirv2_api_key'));
		$linenumber = ($this->config->get('smsirv2_line_number'));
		$debug    = $this->config->get('smsirv2_debug');
		$massage  = str_replace(array('https://','http://','www.'), array('','',''), $message);
        $this->log->write('smsirv2 9 send 1');
		if($debug == 1){
			$result = "SMS DEBUG(catalog): Reciver: {$receiver} - message : {$massage}";
			error_log($result);
			$this->log->write($result);
			$this->session->data['success'] = $result;
			return 'debug';
		}
        $this->log->write('smsirv2 9');
		if ( empty( $api_key ) || empty( $linenumber ) ||  empty( $receiver ) ||  (empty( $message ) && !$otp_send) ) {
            $this->log->write('smsirv2 -9' . json_encode([
                    'apikey' => $api_key,
                    'linenumber' => $linenumber,
                    'reciever' => $receiver,
                    'message' => $message
                ]));
			return $response;
		}

        $this->log->write('smsirv2 10');
        if (!$otp_send){
            $this->log->write('smsirv2 10 bulk');
            $url = "/send/bulk";
            $params = [
                'lineNumber' => $receiver,
                'messageText' => $message,
                'mobiles' => [$receiver],
            ];
        } else {
            $this->log->write('smsirv2 10 verify');
            $url = '/send/verify';
            $params = [
                'mobile' => $receiver,
                'templateId' => $otp_send,
                'parameters' => []
            ];
            $message_keys = array_keys($message);
            foreach ($message_keys as $key){
                $params['parameters'][]  = [
                    'name' => $key,
                    'value' => $message[$key]
                ];
            }
        }
        $this->log->write($params);
        $result = $this->cUrl( $url, $params, 'POST' );
        $this->log->write($result);
        $response = json_decode($result);
        if ($response-> status == 1) {
            return $result;
        }else{
            $this->log->write($this->getErrors($response->status));
            $this->session->data['warning'] = $this->getErrors($response->status);
            error_log($response->status . ':' .$this->getErrors($response->status));
            return $response->status . ':' .$this->getErrors($response->status);
        }
	}

	public function sendOtp($receiver,$template=NULL) {
		$error='';$response_arr=array();
		$rand = rand('1111','99999');
		$this->session->data['smsirv2_otp'] = $rand;
		$template = strip_tags(str_replace(array('[url]','[otp]'), array(HTTPS_SERVER,$rand), html_entity_decode($template)));

		$country_code=$this->config->get('smsalert_country');
		$no = preg_replace('/[^0-9]/', '', $receiver);
		$no = ltrim($no, '0');
		$no = trim($no, ' ');
		$match = preg_match($this->getPhonePattern(),$no);
		/*closed added on 06-05-2019 */
		if($match)
		{
			$no = (substr($no,0,strlen($country_code))!=$country_code) ? $country_code.$no : $no;
			$cookie_value = $this->get_smsirv2_cookie($no);
		    $max_otp_resend_allowed = $this->config->get('smsalert_resend_allowed')!=''?$this->config->get('smsalert_resend_allowed'):'4';
			if($this->get_smsirv2_cookie($no)>$max_otp_resend_allowed)
			{
				$data=array();
				$data['error']= 'You have reached to max allowed resend, please try after 15 minutes';
				return $data;
			}
			$response = $this->sendSMS($no,$template);
			if($response == true){
				$response_arr['status'] = 'success';
			}
			if($response_arr['status']=='error') {
				$error = $response;
		   }
		   else{
			   $this->create_smsirv2_cookie($no,$cookie_value+1);
		   }
		}
		else{
			$error = 'invalid numbers';
		}
		 $response_arr['error']=$error;
		return $response_arr;
	}


	public function verifyOtp($receiver,$code) {
		$error='';$response_arr=array();
		if (!isset($this->session->data['smsirv2_otp'])) {
			return;
		}

		/*added on 06-05-2019 */
		$country_code=$this->config->get('smsalert_country');
	    $no = preg_replace('/[^0-9]/', '', $receiver);
		$no = ltrim($no, '0');
		$no = trim($no, ' ');
		$no = (substr($no,0,strlen($country_code))!=$country_code) ? $country_code.$no : $no;
		$match = preg_match($this->getPhonePattern(),$no);
		/*closed added on 06-05-2019 */
		$response_arr['status'] = 'false';

		if($match)
		{
			if($this->session->data['smsirv2_otp'] == $code){
				$this->clear_smsirv2_cookie($no);
				$response_arr['status'] = 'success';
				$response_arr['description']['desc'] = 'Code Matched successfully.';
			} else {
				$response_arr['description']['desc'] = 'Code invalid!';
			}
		} else {
			$response_arr['description']['desc'] = 'Code invalid!';
		}
		return $response_arr;
	}
	/* دستور ارتباط با وب سرویس */
	private function cUrl( $url, $params = array() , $method = 'POST', $headers = array() ) {
        $api_key = $this->config->get('smsirv2_api_key');
        $headers[] = 'X-API-KEY: '. $api_key;
        $headers[] = 'Content-Type:application/json';
        $domain = "https://api.sms.ir/v1";
		$handler = curl_init($domain.$url);
		curl_setopt($handler, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($handler, CURLOPT_TIMEOUT, 20);
		curl_setopt($handler, CURLOPT_CUSTOMREQUEST, $method);
        curl_setopt($handler, CURLOPT_HTTPHEADER, $headers);
        if($method == 'POST') curl_setopt($handler, CURLOPT_POSTFIELDS, json_encode($params));
		curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($handler);
		return $result;
	}
	/* لیست خطاهای وب سرویس*/
	private function getErrors($error){
		$errorCodes = array(
            '1'  => 'عملیات با موفقیت انجام شده است.',
            '0'  => 'مشکلی در سامانه رخ داده است، لطفا با پشتیبانی در تماس باشید',
            '10'  => 'کلید وب سرویس نامعتبر است',
            '11'  => 'کلید وب سرویس غیرفعال است',
            '12'  => 'کلید وب‌ سرویس محدود به IP‌های تعریف شده می‌باشد',
            '13'  => 'حساب کاربری غیر فعال است',
            '14'  => 'حساب کاربری در حالت تعلیق قرار دارد',
            '20'  => 'تعداد درخواست بیشتر از حد مجاز است',
            '101'  => 'شماره خط نامعتبر می‌باشد',
            '102'  => 'اعتبار کافی نمی‌باشد',
            '103'  => 'درخواست شما دارای متن (های) خالی است',
            '104'  => 'درخواست شما دارای موبایل (های) نادرست است',
            '105'  => 'تعداد موبایل ها بیشتر از حد مجاز (100 عدد) می‌باشد',
            '106'  => 'تعداد متن ها بیشتر از حد مجاز (100 عدد) می‌باشد',
            '107'  => 'لیست موبایل ها خالی می‌باشد',
            '108'  => 'لیست متن ها خالی می‌باشد',
            '109'  => 'زمان ارسال نامعتبر می‌باشد',
            '110'  => 'تعداد شماره موبایل‌ها و تعداد متن ها برابر نیستند',
            '111'  => 'با این شناسه ارسالی ثبت نشده است',
            '112'  => 'رکوردی برای حذف یافت نشد',
            '113'  => 'قالب یافت نشد',
            '114'  => 'طول رشته مقدار پارامتر، بیش از حد مجاز (64 کاراکتر) می‌باشد',
            '115'  => 'شماره موبایل(ها) در لیست سیاه سامانه می‌باشند',

		);
		return (isset($errorCodes[$error])) ? $errorCodes[$error] : 'اشکال تعریف نشده با کد :' . $error;
	}
	public function getPhonePattern()
	{
		$country_code=$this->config->get('smsalert_country');
		$pattern = ($this->config->get('smsalert_mobile_pattern')!='') ? $this->config->get('smsalert_mobile_pattern'):self::PATTERN_PHONE;

		$country_code = str_replace('+', '', $country_code);
		$pattern_phone = str_replace("country_code",$country_code,$pattern);
		return $pattern_phone;
	}
	function create_smsirv2_cookie($cookie_key,$cookie_value)
	{
		ob_start();
		setcookie($cookie_key,$cookie_value, time()+(15 * 60));
		ob_get_clean();
	}

	function clear_smsirv2_cookie($cookie_key)
	{
		if(isset($_COOKIE[$cookie_key])){
			unset($_COOKIE[$cookie_key]);
			setcookie( $cookie_key, '', time() - ( 15 * 60 ) );
		}
	}

	function get_smsirv2_cookie($cookie_key)
	{
		if(!isset($_COOKIE[$cookie_key])) {
		  return false;
		} else {
		  return $_COOKIE[$cookie_key];
		}
	}
}
